var bvqx = BrainVoyagerQX;
var $ = bvqx.FindChild;

var scriptObj = new Object;
scriptObj.scriptNameForUser = "ImageCalculator";
scriptObj.dialogFileName = "ImageCalculatorPlugin_v01.ui";
scriptObj.dialogAccessName = "PluginDialog";

var vmr;
var listX, listY;
var editFormula, editFilenameSuffix;
/*widget names:
 btnAdd1, listX
btnAdd2
btnCalculate
btnClose

*/


//function add1(index) {
scriptObj.add1 = function () {

   // BrainVoyagerQX.PrintToLog("add1...");

  //  BrainVoyagerQX.PrintToLog("ActiveDocument:" + bvqx.ActiveDocument);
    // if there is no VMR doc:
    if (bvqx.ActiveDocument == null) {
        var filename = bvqx.BrowseFile("No files open, please select a VMR file in the same space as the VTC(s)", "*.vmr");
        vmr = bvqx.OpenDocument(filename);
    } else {
        // check whether this is a VMR document
       // HasSliceTimeTable
    }

    var filename = bvqx.BrowseFile("Please select a VTC file", "*.vtc"); // needs to change to smart filter function
    bvqx.PrintToLog("Selected: " + filename);
    if (filename) {
        listX.addItem(filename);
   //     	var edit = $("editFilesX"+index);
   // 	    var edit = $("editFilesX");
    //	    edit.text = filename;
    }
    var nfilesx = listX.count;
    bvqx.PrintToLog("Number of X files: " + nrOfVTCfiles.toString());
    bvqx.PrintToLog("Names: ");
    var filelist = "";
    for (var i = 0; i < nfilesx; i++) {
        //      bvqvx.PrintToLog("Name " + (i+1).toString() + ": " + listX.item(i).text());
     //   bvqvx.PrintToLog("Name " + listX.item(i).text());
        var filename = listX.item(i).text();
        bvqx.PrintToLog(filename);
        filelist += filename;
        if (i < (nfilesx - 1)) filelist += ",";
    }
    bvqx.PrintToLog(filelist);
    //var allItems = listX.items().text();
    //bvqx.PrintToLog(allItems);
}


//o.initDlg = function () {
scriptObj.initDlg = function() {
    var dlg = this.PluginDialog;

    // Enter parameters tab
  //  $("btnAdd1").clicked.connect(function() { select_input(0); });
    // $("btnAdd2").clicked.connect(function() { select_input(1); }); //?
    //  $("btnAdd1").clicked.connect(function () { add1(0); });

    $("btnAdd1").clicked.connect(this, this.add1);
    $("btnClose").clicked.connect(this, this.close);
    $("btnCalculate").clicked.connect(this, this.calculate);

    listX = bvqx.FindChild("listX");
    listY = bvqx.FindChild("listY");
    editFormula = bvqx.FindChild("editFormula");
    editFilenameSuffix = bvqx.FindChild("editFilenameSuffix");

}


// Called for the Close buttons.
scriptObj.close = function() {
    this.PluginDialog.close();
}


// Called for the Run button on the Data entry tab.
scriptObj.calculate = function() {

   /* // open FMR/DMR -- the C++ code needs an open FMR/DMR to create .map files
    var file0 = $("filenameEdit0").text;
    bvqx.OpenDocument(file0);*/

    // set parameters
    bvqx.SetPluginStringParameter("formula", editFormula.text);//$("editFormula").text);
    bvqx.SetPluginStringParameter("suffix", editFilenameSuffix.text);//$("editFilenameSuffix").text);
    // how do I send over the files?
    var filelist = "";
    var nfiles = listX.count;
    for (var i = 0; i < nfiles; i++) {
        //      bvqvx.PrintToLog("Name " + (i+1).toString() + ": " + listX.item(i).text());
        //   bvqvx.PrintToLog("Name " + listX.item(i).text());
        var filename = listX.item(i).text();
        filelist += filename;
        if (i < (nfiles - 1)) filelist += ",";
    }
    bvqx.SetPluginIntParameter("NfilesX", nfiles);
    bvqx.SetPluginStringParameter("filesX", filelist);

    var nfilesY = listY.count;
    bvqx.SetPluginIntParameter("NfilesY", nfilesY);

/*    bvqx.SetPluginStringParameter("file0", file0);
    bvqx.SetPluginStringParameter("file1", $("filenameEdit1").text);
    bvqx.SetPluginIntParameter("volume0", $("volumeSpinBox0").value - 1);
    bvqx.SetPluginIntParameter("volume1", $("volumeSpinBox1").value - 1);
    bvqx.SetPluginIntParameter("rllr", $("estimateRllrRadioButton").checked);
    bvqx.SetPluginIntParameter("use_ssd", $("ssdRadioButton").checked);
    bvqx.SetPluginIntParameter("apply_to_input", $("applyToInput").checked);
*/
    // call C++ function
    bvqx.SetPluginStringParameter("Command", "calculate");
    bvqx.ExecutePlugin();
    this.close();
}


returnScriptObj = function () {
    return scriptObj; // it is important to return script object containing properties and functions to be called from BrainVoyager QX
}
returnScriptObj()
